/*
 * WallFire -- a comprehensive firewall administration tool.
 * 
 * Copyright (C) 2001 Herv Eychenne <rv@wallfire.org>
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 */

#ifndef _DEFS_H
#define _DEFS_H

#define WALLFIRE_AUTHOR_EMAIL_ADDR "rv@wallfire.org"
#define WALLFIRE_URL "http://www.wallfire.org/"

#include "lib.h"

#include "rvlog.h"

#define WFASSERT(msg)  do {					       	      \
    fprintf(stderr,						              \
	    _("%s:%i: Warning: assertion failed in function `%s': %s\n"),     \
  	  __FILE__, __LINE__, __func__, msg);			              \
    cerr << _("This should not have happened, please signal it to the author.") << '\n'; \
  } while(0);

extern rvlog wflogs_log; // RV@@9
/*
//#define wf_log(level, format, args...) \
//rvlog_loghandle.rvlog_log(, level, format , ## args)
*/

#endif /* _DEFS_H */
